 /*  
 *  Sensor Squid
 *  based on Arduino2Max
 *  Send pin values from Arduino to MAX/MSP
 *  key changes from Arduino2Max: 
 *  added RFID tag information to outgoing packet
 *  (from incoming serial data from an ID-12 RFID reader)
 *  
 *
 *  SensorSquid.pde
 *  ------------  
 *  Arduino2Max version: .4, October 2007
 *  SensorSquid version: .2, November 2007
 *  ------------
 *  
 *  Copyright Arizona State University 
 *  Licenced under the Creative Commons 
 *  Attribution-Noncommercial 3.0 license: 
 *  http://creativecommons.org/licenses/by-nc/3.0/ 
 *
 *  Original Copyleft Daniel Jolliffe
 *  Based on a sketch and patch by Thomas Ouellet Fredericks  tof.danslchamp.org
 *  Modified further by Rebecca Stern at Arts, Media and Engineering at ASU (http://ame.asu.edu)
 */


int x = 0;                              // a place to hold pin values
int ledpin = 13;
char val = 0;
char rfidTag[13] = {'0','0','0','0','0','0','0','0','0','0','0','0','\0'};
char rfidTagStable[13] = {'0','0','0','0','0','0','0','0','0','0','0','0','\0'};
int counter = 0;


void setup()
{
  delay(1000);
  Serial.begin(9600);               // 115200 is the default Arduino Bluetooth speed
  digitalWrite(13,HIGH);              ///startup blink
  
  digitalWrite(13,LOW);
  pinMode(13,INPUT);
}



void loop()
{ 

if (Serial.available() > 0){         // Check serial buffer for characters
        
    val = Serial.read();
    if((val >= 48 && val <= 57) || (val >= 65 && val <= 90)){  //strip out all characters except numbers and letters
      rfidTag[counter] = val;
      counter++;
    
    }
    
                        


 }
  
 for (int pin= 0; pin<=5; pin++){      // Read and send analog pins 0-5
    x = analogRead(pin);
    sendValue (x);
    }

for (int pin= 2; pin<=13; pin++){     // Read and send digital pins 2-13
    x = digitalRead(pin);
    sendValue (x);
    }
    
    if (counter > 11){
      for(int i=0;i<12;i++){
        rfidTagStable[i] = rfidTag[i];
      }
      counter = 0;
    }
    Serial.print(rfidTagStable);
    
  
    Serial.println();                 // Send a carriage return to mark end of pin data. 
    delay (5);                        // add a delay to prevent crashing/overloading of the serial port
    
 

}

void sendValue (int x){              // function to send the pin value followed by a "space". 
 Serial.print(x);
 Serial.print(32, BYTE); 
}



